<?php
error_reporting(E_ALL & ~E_NOTICE);
define('NO_REGISTER_GLOBALS', 1);

if (!$_REQUEST['do'])
{
	$_REQUEST['do'] = 'home';
}

require_once('./global.php');

print_cp_header('ibProArcade -&gt; v3 Arcade');


print_table_start();
print_table_header('Import');

if ($_REQUEST['do'] == 'home')
{
	print_description_row('<strong>Warning! This import script will delete all data from your v3 Arcade installation, so only proceed if you want to wipe your current data and import from ibProArcade.<div style="padding-top: 15px"><a href="v3arcade_ipb_import.php?do=games">Begin the import --&gt;</a></div>');
	
}

// ##### Import Games
if ($_REQUEST['do'] == 'games')
{
	$db->query_write("TRUNCATE " . TABLE_PREFIX . "v3arcade_games");
	$db->query_write("TRUNCATE " . TABLE_PREFIX . "v3arcade_ratings");

	$messages = '';

	$games = $db->query("
		SELECT *
		FROM " . TABLE_PREFIX . "games_list
	");
	while ($game = $db->fetch_array($games))
	{
		$game['votepoints'] = 0;
		$game['votecount'] = 0;

		// Ratings		
		if ($game['g_rating'])
		{
			$game['g_raters'] = unserialize($game['g_raters']);

			if (!empty($game['g_raters']))
			{
				foreach ($game['g_raters'] AS $r_userid => $r_rating)
				{
					$game['votecount']++;
					$game['votepoints'] += $r_rating;
					
					$db->query_write("
						INSERT INTO " . TABLE_PREFIX . "v3arcade_ratings
							(gameid, userid, rating)
						VALUES (
							$game[gid],
							$r_userid,
							$r_rating
					)");
				}
			}
		}

		// Flash file
		if (is_file('./arcade/' . $game['gname'] . '.swf') AND !is_file('./games/' . $game['gname'] . '.swf'))
		{
			if (!copy(
				'./arcade/' . $game['gname'] . '.swf',
				'./games/' . $game['gname'] . '.swf'
			))
			{
				$messages .= '<div>Warning: ' . $game['gname'] . '.swf could not be copied.</div>';
			}
		}

		// Images
		if (is_file('./arcade/images/' . $game['gname'] . '1.gif'))
		{
			copy(
				'./arcade/images/' . $game['gname'] . '1.gif',
				'./images/arcade/' . $game['gname'] . '1.gif'
			);
		}

		if (is_file('./arcade/images/' . $game['gname'] . '2.gif'))
		{
			copy(
				'./arcade/images/' . $game['gname'] . '2.gif',
				'./images/arcade/' . $game['gname'] . '2.gif'
			);
		}

		$gsession = $db->query_first("
			SELECT COUNT(*) AS count
			FROM " . TABLE_PREFIX . "games_scores
			WHERE gid = $game[gid]
		");

		if (!$game['bestscore'])
		{
			$game['bestscore'] = 0;
		}

		$game['perms'] = 6;
		
		if ($game['active'])
		{
			$game['perms'] += 1;
		}
		
		if (!$game['record_score'])
		{
			$game['perms'] += 8;
		}

		// Insert the game
		$db->query_write("
			INSERT INTO " . TABLE_PREFIX . "v3arcade_games
				(gameid, shortname, title, description, instructions, file, width, height, miniimage, stdimage, gamepermissions, categoryid, timesplayed, dateadded, system, votepoints, votecount, sessioncount, highscorerid, highscore, isreverse)
			VALUES (
				$game[gid],
				'$game[gname]',
				'" . $db->escape_string($game['gtitle']) . "',
				'" . $db->escape_string($game['gwords']) . "',
				'" . $db->escape_string($game['object']) . "',
				'$game[gname].swf',
				'$game[gwidth]',
				'$game[gheight]',
				'$game[gname]2.gif',
				'$game[gname]1.gif',
				$game[perms],
				" . ($game['gcat'] + 2) . ",
				$game[gcount],
				$game[added],
				10,
				$game[votepoints],
				$game[votecount],
				$gsession[count], 
				$game[bestmid],
				$game[bestscore],
				" . ($game['highscore_type'] == 'high' ? 0 : 1) . "
		)");

	}

	if ($messages)
	{
		$messages .= '<br />';
	}

	print_description_row($messages . 'Games imported.<br /><br /><a href="v3arcade_ipb_import.php?do=cats">Click here to continue --&gt;</a>');
}

// ##### Import Categories
if ($_REQUEST['do'] == 'cats')
{
	$db->query_write("DELETE FROM " . TABLE_PREFIX . "v3arcade_categories WHERE categoryid > 2");
	
	$getcats = $db->query_read("
		SELECT *
		FROM " . TABLE_PREFIX . "games_cats
	");
	while ($cat = $db->fetch_array($getcats))
	{
		$db->query_write("
			INSERT INTO " . TABLE_PREFIX . "v3arcade_categories
				(categoryid, catname, displayorder, isactive)
			VALUES (
				" . ($cat['c_id'] + 2) . ",
				'" . $db->escape_string($cat['cat_name']) . "',
				$cat[pos],
				$cat[active]
		)");
	}
	
	print_description_row('Categories imported.<br /><br /><a href="v3arcade_ipb_import.php?do=tour">Click here to continue --&gt;</a>');
}

// ##### Import Tournaments
if ($_REQUEST['do'] == 'tour')
{
	$db->query_write("TRUNCATE " . TABLE_PREFIX . "v3arcade_tournaments");     
	$db->query_write("TRUNCATE " . TABLE_PREFIX . "v3arcade_tournamentplayers");

	$usernames = array();
	$gettour = $db->query_read("
		SELECT champion, creat
		FROM " . TABLE_PREFIX . "tournaments AS tour
	");
	while ($tour = $db->fetch_array($gettour))
	{
		$usernames[] = $tour['champion'];
		$usernames[] = $tour['creat'];
	}

	$usercache = array();
	$getusers = $db->query_read("
		SELECT userid, username
		FROM " . TABLE_PREFIX . "user
		WHERE username IN('" . implode("', '", $usernames) . "')
	");
	while ($user = $db->fetch_array($getusers))
	{
		$usercache[$user['username']] = $user['userid'];
	}


	$champtours = array();
	$gettour = $db->query_read("
		SELECT tour.*, user.userid, games.gtitle
		FROM " . TABLE_PREFIX . "tournaments AS tour
		LEFT JOIN " . TABLE_PREFIX . "user AS user ON (tour.creat = user.username)
		LEFT JOIN " . TABLE_PREFIX . "games_list AS games ON (tour.gid = games.gid)
	");
	while ($tour = $db->fetch_array($gettour))
	{
		if ($tour['champion'])
		{
			$champtours[] = $tour['tid'];
		}
		
		$db->query_write("
			INSERT INTO " . TABLE_PREFIX . "v3arcade_tournaments
			 (tid, title, gameid, creator, datestamp, roundstart, status, numplayers, numtries, openslots, round, winner, gametitle)
			VALUES(
				$tour[tid],
				'" . $db->escape_string($tour['creat'] . ' ' . vbdate($vbulletin->options['dateformat'], $tour['datestarted'])) . "',
				$tour[gid],
				" . intval($tour['userid']) . ",
				$tour[datestarted],
				$tour[datestarted],
				" . ($tour['champion'] ? 2 : 0) . ",
				$tour[numplayers],
				$tour[nbtries],
				0,
				0,
				'" . $usercache[$tour['champion']] . "',
				'" . $db->escape_string($tour['gtitle']) . "'
		)");
				
				
	}

	$lasttid = 0;
	$slot = -1;

	$members = array();
	$gettp = $db->query_read("
		SELECT tp.*, tps.statut, t.nbtries, t.numplayers, t.champion
		FROM " . TABLE_PREFIX . "tournament_players AS tp
		LEFT JOIN " . TABLE_PREFIX . "tournaments AS t ON (tp.tid = t.tid)
		LEFT JOIN " . TABLE_PREFIX . "tournament_players_statut AS tps ON (tp.tid = tps.tid AND tp.mid = tps.mid)
		ORDER BY tp.tid, rung DESC, rungscore DESC
	");
	while ($tp = $db->fetch_array($gettp))
	{
		if ($lasttid != $tp['tid'])
		{
			if ($lasttid)
			{
				$openslots = $lastnumplayers - sizeof(array_unique($members));

				$db->query_write("
					UPDATE " . TABLE_PREFIX . "v3arcade_tournaments SET
						openslots = $openslots
						" . ((!$openslots AND !$lastchamp) ? ', status = 1' : '')
						. (in_array($lasttid, $champtours) ? '' : ", round = $lastround") . "
					WHERE tid = $lasttid
				");
			}


			$slot = -1;
			$lasttid = $tp['tid'];
			$lastnumplayers = $tp['numplayers'];
			$lastchamp = $tp['champion'];
			$members = array();
		}

		$members[] = $tp['mid'];

		if ($currentround != $tp['rung'])
		{
			if ($tp['rung'] == 1)
			{
				// Insert the winner
				$db->query_write("
					INSERT INTO " . TABLE_PREFIX . "v3arcade_tournamentplayers
						(tid, userid, datestamp, score, tries, round, slot, status, playing, notified)
					VALUES (
						$tp[tid],
						$tp[mid],
						$tp[timeplayed],
						$tp[rungscore],
						$tp[timesplayed],
						0,
						0,
						30,
						0,
						$tp[notified]
				)");
			}
			
			$slot = -1;
			$currentround = $tp['rung'];
		}

		$lastround = $tp['rung'];

		$slot++;
		
		switch ($tp['statut'])
		{
			case 3:
				$status = 30;
			break;

			case 2:
				$status = 20;
			break;

			case 1:
				$status = 10;
			break;

			default:
				$status = 0;
		}
		
		$db->query_write("
			INSERT INTO " . TABLE_PREFIX . "v3arcade_tournamentplayers
				(tid, userid, datestamp, score, tries, round, slot, status, playing, notified)
			VALUES (
				$tp[tid],
				$tp[mid],
				$tp[timeplayed],
				$tp[rungscore],
				$tp[timesplayed],
				$tp[rung],
				$slot,
				$status,
				0,
				$tp[notified]
		)");
	}

	if ($lasttid)
	{
		$openslots = $lastnumplayers - sizeof(array_unique($members));

		$db->query_write("
			UPDATE " . TABLE_PREFIX . "v3arcade_tournaments SET
				openslots = $openslots
				" . ((!$openslots AND !$lastchamp) ? ', status = 1' : '')
				. (in_array($lasttid, $champtours) ? '' : ", round = $lastround") . "
			WHERE tid = $lasttid
		");
	}


	require_once('./includes/v3arcade_functions.php');
	build_tournament_cache();
	
	print_description_row('Tournaments imported.<br /><br /><a href="v3arcade_ipb_import.php?do=scores">Click here to continue --&gt;</a>');
}

// ##### Import Scores
if ($_REQUEST['do'] == 'scores')
{
	$db->query_write("TRUNCATE " . TABLE_PREFIX . "v3arcade_sessions");

	$scores = $db->query("
			SELECT games_scores.*, games.gname
			FROM " . TABLE_PREFIX . "games_scores AS games_scores
			LEFT JOIN " . TABLE_PREFIX . "games_list AS games ON (games_scores.gid = games.gid)
			ORDER BY score
	");
	while ($score = $db->fetch_array($scores))
	{
		$db->query_write("
			INSERT INTO " . TABLE_PREFIX . "v3arcade_sessions
				(sessionid, gameid, gamename, userid, start, finish, ping, comment, valid, score, sessiontype)
			VALUES (
				'$score[s_id]',
				$score[gid],
				'$score[gname]',
				$score[mid],
				$score[datescored],
				" . ($score['datescored'] + $score['timespent']) . ",
				'0.00',
				'" . $db->escape_string($score['comment']) . "',
				1,
				$score[score],
				1
		)");

	}

	require_once('./includes/v3arcade_functions.php');
	
	build_arcade_latest();
	build_arcade_champ_cache();

	require_once('./includes/v3arcade_functions_admin.php');
	build_cat_cache();

	print_description_row('Scores imported.<br /><br />Import Complete!');

}

print_table_footer();


print_cp_footer();

?>
